//Die Klasse Feld wird genutzt, um Feld-Objekte zu erzeugen.
//Objekte der Klasse Feld sind von TLabel abgeleitet.
//Beim Anklicken verndern sie ihr Aussehen.
class Feld : public TLabel
{
   private:
     Spieler* belongsToPlayer;              //Besitzer des Spielfelds

   public:
     __fastcall Feld(AnsiString name,       //Name des Felds
          TComponent* Owner,                //Objektbesitzer
          TWinControl* parent,              //Elternelement
          unsigned int width,               //Breite
          unsigned int height,              //Hhe
          unsigned int top,                 //y-Koordinate
          unsigned int left,                //x-Koordinate
          TColor cl)                        //Feldfarbe
     : TLabel(Owner)                        //Konstrukturaufruf von TLabel
     {
       this->Color = cl;
       this->AutoSize = false;              //Das Feld soll sich nicht dem Inhalt anpassen
       this->Font->Color = clWhite;
       this->Parent = parent;
       this->Caption = " ";                 //Auf dem Feld soll nichts stehen
       this->ShowHint = true;               //Hinweis beim berfahren mit der Maus: ja
       this->Hint = "Leeres Feld";          //Standarttext des Hinweises
       this->Top = top;
       this->Left = left;
       this->Width = width;
       this->Height = height;
       this->Name = name;
       this->belongsToPlayer = NULL;        //Anfangs besitzerlos
       this->Layout = tlCenter;             //in y-Richtung zentrieren
       this->Alignment = taCenter;          //in x-Richtung zentrieren
       this->Font->Size = 10;
       this->Font->Style = TFontStyles()<< fsBold;   //Fette Schrift
     }

     void setColor(TColor farbe)
     {
       this->Color = farbe;                 //Feldfarbe ndern
     }

     TColor getColor()
     {
       return this->Color;                 //Feldfarbe zurckgeben
     }

     void setPlayer(Spieler* pl)           //Besitzer setzen
     {
       this->belongsToPlayer = pl;
       this->Caption = this->belongsToPlayer->getName();   //Name als Beschriftung
       this->Hint = "Feld belegt von "+this->Caption;      //Hint setzen
     }

     Spieler* getPlayer()
     {
       return this->belongsToPlayer;                //Spielerzeiger zurckgeben
     }

     bool isEmpty()
     {
       return this->belongsToPlayer == NULL;        //Hat das Feld einen Besitzer?
     }

     void setEmpty()
     {
       this->belongsToPlayer = NULL;               //Besitzer lschen
       this->Caption = " ";                        //Beschriftung leeren
       this->Hint = "Leeres Feld";                 //Hinweistext zurcksetzen
     }
};

