//VIEW


//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "__headers.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  //Mit dieser Zeile wird der Spielablauf in Gang gesetzt.
  //Dem Konstruktor des Controllers wird ein Zeiger auf die GUI bergeben
  this->controller = new Controller(this);
}


void __fastcall TForm1::Optionen1Click(TObject *Sender)
{
  //Da das Optionsmen ein neues Formular ist, muss es erst sichtbar
  //gemacht werden.
  Form2->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Beenden1Click(TObject *Sender)
{
 //Das Programm beenden
 Application->Terminate();
}

//Diese Methode aktualisiert die GUI
void TForm1::RefreshField()
{
 Feld* feld;    //Temporrer Feld*-Speicher
 for(int y = 0; y < CONST__anzY; y++)
 {
   for(int x = 0; x < CONST__anzX; x++)
   {
     feld = this->controller->getModel()->getFeld(x,y);  //Das Feld steht jetzt in feld
     if(!feld->isEmpty())                                //Wenn das Feld nicht leer ist
     {
       feld->setColor(feld->getPlayer()->getColor());    //Dann wird die Farbe des Besitzers bernommen
       feld->Caption = feld->getPlayer()->getName();     //Und der Name des Besitzers wird die Beschriftung
     }
     else
     {
       //Das Feld ist leer
       //Deshalb wird die EmptyFieldColor-Farbe benutzt
       feld->setColor(this->controller->getModel()->getEmptyFieldColor());
     }
   }
 }
 //Hintergrund des Spielfelds einfrben
 //Der Hintergrund stellt eigentlich die Trennlinien dar, weil der Rest
 //durch die einzelnen Felder bedeckt ist
 this->panel_feldcontainer->Color = this->controller->getModel()->getBackgroundColor();
}

//Den Statustext ndern
void TForm1::setStatusMessage(AnsiString msg)
{
  this->label_status->Caption = msg;
}

//Anzahl gemachter Spielzge anzeigen
void TForm1::showSpielzuege(int zuege)
{
  this->label_spielzuege->Caption = "Spielzge: "+IntToStr(zuege);
}

//Diese Methode platziert alle Elemente relativ zueinander auf dem Spielfeld
void  TForm1::placeElements()
{
      //Die x-Koordinate des Spielfelds mit den einzelnen Feldern als Inhalt
      //berechnet sich aus der Differenz der Breite des Fensters und der Breite des Spielfelds
      //Das Ganze wird dann durch 2 geteilt, um die Mitte zu finden und um 3 Pixel nach links
      //verschoben, da die Rnder nicht bercksichtigt wurden.
      this->panel_feldcontainer->Left = (this->Width - this->panel_feldcontainer->Width) / 2 -3;

      //Die y-Koordinate des Spielfelds mit den einzelnen Feldern als Inhalt
      //wird aus der Differenz der Formularhhe, der Spielfeldhhe, der Titelleistenhhe
      //und der Menleistenhhe berechnet. Alles wird dann durch 2 geteilt, um das
      //Spielfeld in der Mitte zu plazieren.
      this->panel_feldcontainer->Top = (this->Height
                                - this->panel_feldcontainer->Height
                                -27 -27) / 2 ;  // 27 ist die Hhe der Titelleiste
                                                // und vom Hauptmen

      //Die y-Koordinate der Spielzugsanzeige wird aus der Summe der Spielfeld-y-Koordinate und der
      //Hhe des Spielfelds berechnet
      this->label_spielzuege->Top = (this->panel_feldcontainer->Top + this->panel_feldcontainer->Height);

      //Die x-Koordinate der Spielzugsanzeige entspricht der y-Koordinate des Spielfelds
      this->label_spielzuege->Left = this->panel_feldcontainer->Left;

      //x-Koordinate der Spieldaueranzeige ist Spiezugzuganzeige(x) + Spielzuganzeige (breite) + 15
      this->label_spieldauer->Left = this->label_spielzuege->Left + this->label_spielzuege->Width + 15;

      //y-Koordinate der Spieldaueranzeige ist gleich wie die y-Koordinate der Spielzuganzeige
      this->label_spieldauer->Top = this->label_spielzuege->Top;

      //Die x-Koordinate der Spielfarbenanzeige entspricht der x-Koordinate des Spielfelds
      this->label_spielerfarbe->Left = this->panel_feldcontainer->Left;

      //Die y-Koordinate der Spielfarbenanzeige ist die Differenz aus y-Koordinate des Spielfelds
      //und Hhe des Status-Labels
      this->label_spielerfarbe->Top = (this->panel_feldcontainer->Top - this->label_status->Height);

      //Das Label sitzt 1 px weiter oben als die Farbe, weil es optisch besser aussieht
      this->label_status->Top  =  this->label_spielerfarbe->Top -1;

      //3px Abstand zwischen Farbe und Status.
      this->label_status->Left  =  this->label_spielerfarbe->Left +   this->label_spielerfarbe->Width + 3;


}

//Liefert den Controller
Controller* TForm1::getController()
{
  return this->controller;
}

//Die Farbe neben der Statusanzeige setzen
void TForm1::setSpielerfarbeVorschau(TColor cl)
{
   this->label_spielerfarbe->Color = cl;
}

//Farbanzeige auf Standartwert (entspricht dem Formularhintergrund) setzen
void TForm1::resetSpielerfarbeVorschau()
{
   this->setSpielerfarbeVorschau(this->Color);
}
//---------------------------------------------------------------------------


//Neues Spiel starten
void __fastcall TForm1::Neu1Click(TObject *Sender)
{
   //Diese Aufgabe wird an Controller::reset() delegiert.
   this->controller->reset();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Info1Click(TObject *Sender)
{
  //Kleinen Info-Text anzeigen
  ShowMessage("Dieses Spiel wurde von Simon Hessner als CT-OOP-Projekt in der Klasse TGI 12/1 programmiert.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Anleitung1Click(TObject *Sender)
{
  //Das Formular der Anleitung anzeigen
  Form3->Visible = true;        
}
//---------------------------------------------------------------------------

//Wird jede Sekunde aufgerufen
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  //Der Controller soll die Anfrage verarbeiten
  this->controller->refreshTimer();
}

//Anhand der Minutenanzahl und der Sekundenanzahl die Ausgabe erstellen
void TForm1::showTimerData(int timer_min, int timer_sec)
{
   AnsiString min = "", sec = ""; //Strings zur Ausgabe

   //Zahlen kleiner 10 bekommen eine 0 vorangestellt
   min = (timer_min < 10) ? "0"+IntToStr(timer_min) : IntToStr(timer_min);
   sec = (timer_sec < 10) ? "0"+IntToStr(timer_sec) : IntToStr(timer_sec);

   //Ausgabe
   this->label_spieldauer->Caption = "Spieldauer: "+min+":"+sec+" min";
}
//---------------------------------------------------------------------------


